diff --git a/makerules/makefile_sbl.mak b/makerules/makefile_sbl.mak
index bc026f3..7af4412 100644
--- a/makerules/makefile_sbl.mak
+++ b/makerules/makefile_sbl.mak
@@ -61,6 +61,44 @@ REMOTE_CORE_LIST_LATEAPP2=
 
 CERT_SCRIPT=$(PDK_PATH)/packages/ti/build/makerules/x509CertificateGen.sh
 
+ifeq ($(BUILD_LINUX_A72), yes)
+ifeq ($(BUILD_CPU_MCU2_0),yes)
+        REMOTE_CORE_LIST_LATEAPP1+=10 $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_mcu2_0.out.rprc
+endif
+ifeq ($(BUILD_CPU_MCU2_1),yes)
+        REMOTE_CORE_LIST_LATEAPP1+=11 $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_mcu2_1.out.rprc
+endif
+ifeq ($(BUILD_CPU_MCU3_0),yes)
+        REMOTE_CORE_LIST_LATEAPP2+=12 $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_mcu3_0.out.rprc
+endif
+ifeq ($(BUILD_CPU_MCU3_1),yes)
+        REMOTE_CORE_LIST_LATEAPP2+=13 $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_mcu3_1.out.rprc
+endif
+ifeq ($(BUILD_CPU_MCU4_0),yes)
+        REMOTE_CORE_LIST_LATEAPP2+=14 $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_mcu4_0.out.rprc
+endif
+ifeq ($(BUILD_CPU_MCU4_1),yes)
+        REMOTE_CORE_LIST_LATEAPP2+=15 $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_mcu4_1.out.rprc
+endif
+ifeq ($(BUILD_CPU_C6x_1),yes)
+        REMOTE_CORE_LIST_LATEAPP2+=16 $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_c6x_1.out.rprc
+endif
+ifeq ($(BUILD_CPU_C6x_2),yes)
+        REMOTE_CORE_LIST_LATEAPP2+=17 $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_c6x_2.out.rprc
+endif
+ifeq ($(BUILD_CPU_C7x_1),yes)
+        REMOTE_CORE_LIST_LATEAPP2+=18 $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_c7x_1.out.rprc
+endif
+ifeq ($(BUILD_CPU_C7x_2),yes)
+        REMOTE_CORE_LIST_LATEAPP2+=19 $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_c7x_2.out.rprc
+endif
+ifeq ($(BUILD_CPU_C7x_3),yes)
+        REMOTE_CORE_LIST_LATEAPP2+=20 $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_c7x_3.out.rprc
+endif
+ifeq ($(BUILD_CPU_C7x_4),yes)
+        REMOTE_CORE_LIST_LATEAPP2+=21 $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_c7x_4.out.rprc
+endif
+else
 ifeq ($(BUILD_CPU_MCU2_0),yes)
 	REMOTE_CORE_LIST_LATEAPP1+=10 $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_qnx_mcu2_0.out.rprc
 endif
@@ -97,6 +135,7 @@ endif
 ifeq ($(BUILD_CPU_C7x_4),yes)
 	REMOTE_CORE_LIST_LATEAPP2+=21 $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_qnx_c7x_4.out.rprc
 endif
+endif
 
 ifeq ($(BUILD_LINUX_A72), yes)
 	SBL_SD_FS_PATH=$(LINUX_SD_FS_BOOT_PATH)
@@ -223,6 +262,16 @@ sbl_mcusw_bootimage_ospi_hs:
 
 sbl_vision_apps_bootimage_1:
 	mkdir -p $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs
+ifeq ($(BUILD_LINUX_A72), yes)
+ifeq ($(BUILD_CPU_MCU2_0),yes)
+	$(TIARMCGT_LLVM_ROOT)/bin/tiarmstrip -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_mcu2_0.out
+	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_mcu2_0.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_mcu2_0.out.rprc
+endif
+ifeq ($(BUILD_CPU_MCU2_1),yes)
+	$(TIARMCGT_LLVM_ROOT)/bin/tiarmstrip -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_mcu2_1.out
+	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_mcu2_1.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_mcu2_1.out.rprc
+endif
+else
 ifeq ($(BUILD_CPU_MCU2_0),yes)
 	$(TIARMCGT_LLVM_ROOT)/bin/tiarmstrip -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_qnx_mcu2_0.out
 	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_qnx_mcu2_0.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_qnx_mcu2_0.out.rprc
@@ -230,6 +279,7 @@ endif
 ifeq ($(BUILD_CPU_MCU2_1),yes)
 	$(TIARMCGT_LLVM_ROOT)/bin/tiarmstrip -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_qnx_mcu2_1.out
 	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_qnx_mcu2_1.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_qnx_mcu2_1.out.rprc
+endif
 endif
 	$(MULTICORE_APPIMAGE_GEN_TOOL_PATH)/MulticoreImageGen LE $(DEV_ID) $(VISION_APPS_PATH)/out/sbl_bootfiles/lateapp1 $(REMOTE_CORE_LIST_LATEAPP1)
 
@@ -239,6 +289,48 @@ sbl_vision_apps_bootimage_hs_1:
 
 sbl_vision_apps_bootimage_2:
 	mkdir -p $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs
+ifeq ($(BUILD_LINUX_A72), yes)
+ifeq ($(BUILD_CPU_MCU3_0),yes)
+	$(TIARMCGT_LLVM_ROOT)/bin/tiarmstrip -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_mcu3_0.out
+	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_mcu3_0.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_mcu3_0.out.rprc
+endif
+ifeq ($(BUILD_CPU_MCU3_1),yes)
+	$(TIARMCGT_LLVM_ROOT)/bin/tiarmstrip -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_mcu3_1.out
+	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_mcu3_1.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_mcu3_1.out.rprc
+endif
+ifeq ($(BUILD_CPU_MCU4_0),yes)
+	$(TIARMCGT_LLVM_ROOT)/bin/tiarmstrip -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_mcu4_0.out
+	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_mcu4_0.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_mcu4_0.out.rprc
+endif
+ifeq ($(BUILD_CPU_MCU4_1),yes)
+	$(TIARMCGT_LLVM_ROOT)/bin/tiarmstrip -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_mcu4_1.out
+	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_mcu4_1.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_mcu4_1.out.rprc
+endif
+ifeq ($(BUILD_CPU_C6x_1),yes)
+	$(CGT6X_ROOT)/bin/strip6x -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/C66/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_c6x_1.out
+	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/C66/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_c6x_1.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_c6x_1.out.rprc
+endif
+ifeq ($(BUILD_CPU_C6x_2),yes)
+	$(CGT6X_ROOT)/bin/strip6x -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/C66/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_c6x_2.out
+	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/C66/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_c6x_2.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_c6x_2.out.rprc
+endif
+ifeq ($(BUILD_CPU_C7x_1),yes)
+	$(CGT7X_ROOT)/bin/strip7x -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/$(C7X_TARGET)/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_c7x_1.out
+	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/$(C7X_TARGET)/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_c7x_1.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_c7x_1.out.rprc
+endif
+ifeq ($(BUILD_CPU_C7x_2),yes)
+	$(CGT7X_ROOT)/bin/strip7x -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/$(C7X_TARGET)/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_c7x_2.out
+	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/$(C7X_TARGET)/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_c7x_2.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_c7x_2.out.rprc
+endif
+ifeq ($(BUILD_CPU_C7x_3),yes)
+	$(CGT7X_ROOT)/bin/strip7x -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/$(C7X_TARGET)/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_c7x_3.out
+	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/$(C7X_TARGET)/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_c7x_3.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_c7x_3.out.rprc
+endif
+ifeq ($(BUILD_CPU_C7x_4),yes)
+	$(CGT7X_ROOT)/bin/strip7x -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/$(C7X_TARGET)/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_c7x_4.out
+	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/$(C7X_TARGET)/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_linux_c7x_4.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_linux_c7x_4.out.rprc
+endif
+else
 ifeq ($(BUILD_CPU_MCU3_0),yes)
 	$(TIARMCGT_LLVM_ROOT)/bin/tiarmstrip -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_qnx_mcu3_0.out
 	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/R5F/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_qnx_mcu3_0.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_qnx_mcu3_0.out.rprc
@@ -278,6 +370,7 @@ endif
 ifeq ($(BUILD_CPU_C7x_4),yes)
 	$(CGT7X_ROOT)/bin/strip7x -p $(VISION_APPS_PATH)/out/$(TARGET_SOC)/$(C7X_TARGET)/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_qnx_c7x_4.out
 	$(SBL_OUT2RPRC_GEN_TOOL_PATH)/out2rprc.exe $(VISION_APPS_PATH)/out/$(TARGET_SOC)/$(C7X_TARGET)/$(RTOS)/$(QNX_APP_PROFILE)/vx_app_rtos_qnx_c7x_4.out $(VISION_APPS_PATH)/out/sbl_bootfiles/rprcs/vx_app_rtos_qnx_c7x_4.out.rprc
+endif
 endif
 	$(MULTICORE_APPIMAGE_GEN_TOOL_PATH)/MulticoreImageGen LE $(DEV_ID) $(VISION_APPS_PATH)/out/sbl_bootfiles/lateapp2 $(REMOTE_CORE_LIST_LATEAPP2)
 