diff --git a/common/spl/Kconfig b/common/spl/Kconfig
index c2cc646f..3dcdfb9c 100644
--- a/common/spl/Kconfig
+++ b/common/spl/Kconfig
@@ -693,7 +693,7 @@ config SPL_FS_FAT
 config SPL_FS_LOAD_PAYLOAD_NAME
 	string "File to load for U-Boot from the filesystem"
 	depends on SPL_FS_EXT4 || SPL_FS_FAT || SPL_FS_SQUASHFS || SPL_SEMIHOSTING
-	default "tispl-falcon.bin" if SYS_K3_SPL_ATF
+	default "tispl.bin" if SYS_K3_SPL_ATF
 	default "u-boot.itb" if SPL_LOAD_FIT
 	default "u-boot.img"
 	help
diff --git a/configs/am62x_evm_r5_defconfig b/configs/am62x_evm_r5_defconfig
index 94579d22..93076bc3 100644
--- a/configs/am62x_evm_r5_defconfig
+++ b/configs/am62x_evm_r5_defconfig
@@ -1,7 +1,6 @@
 CONFIG_ARM=y
 CONFIG_ARCH_K3=y
 CONFIG_TI_SECURE_DEVICE=y
-CONFIG_SYS_TEXT_BASE=0x83000000
 CONFIG_SPL_STACK_R_MALLOC_SIMPLE_LEN=0x200000
 CONFIG_SYS_MALLOC_F_LEN=0x9000
 CONFIG_SPL_LIBCOMMON_SUPPORT=y
@@ -24,7 +23,7 @@ CONFIG_DM_RESET=y
 CONFIG_SPL_MMC=y
 CONFIG_SPL_SERIAL=y
 CONFIG_SPL_DRIVERS_MISC=y
-CONFIG_SPL_STACK_R_ADDR=0x89000000
+CONFIG_SPL_STACK_R_ADDR=0x82000000
 CONFIG_SPL_SYS_MALLOC_F_LEN=0x7000
 CONFIG_SPL_SIZE_LIMIT=0x3A7F0
 CONFIG_SPL_SIZE_LIMIT_PROVIDE_STACK=0x3500
@@ -33,7 +32,7 @@ CONFIG_SPL_LIBDISK_SUPPORT=y
 CONFIG_SPL_SPI_FLASH_SUPPORT=y
 CONFIG_SPL_SPI=y
 CONFIG_SPL_LOAD_FIT=y
-CONFIG_SPL_LOAD_FIT_ADDRESS=0x84000000
+CONFIG_SPL_LOAD_FIT_ADDRESS=0x80080000
 CONFIG_SPL_FIT_IMAGE_POST_PROCESS=y
 # CONFIG_DISPLAY_CPUINFO is not set
 CONFIG_SPL_SIZE_LIMIT_SUBTRACT_GD=y
diff --git a/include/configs/am62x_evm.h b/include/configs/am62x_evm.h
index 5a51bf42..ff369e90 100644
--- a/include/configs/am62x_evm.h
+++ b/include/configs/am62x_evm.h
@@ -38,8 +38,4 @@
 #define CFG_SYS_NAND_ECCBYTES        14
 /*-- end NAND config --*/
 
-#ifdef CONFIG_SYS_K3_SPL_ATF
-#define CONFIG_SPL_FS_LOAD_PAYLOAD_NAME "tispl-falcon.bin"
-#endif
-
 #endif /* __CONFIG_AM625_EVM_H */
diff --git a/include/configs/ti_armv7_common.h b/include/configs/ti_armv7_common.h
index db209cab..dbbeff34 100644
--- a/include/configs/ti_armv7_common.h
+++ b/include/configs/ti_armv7_common.h
@@ -31,21 +31,6 @@
  * blob before loading the ramdisk, as DTBO location is only used as a temporary
  * storage, and can be re-used after 'fdt apply' command is done.
  */
-#if defined(CONFIG_CPU_V7R) && defined(CONFIG_SOC_K3_AM625)
-#define DEFAULT_LINUX_BOOT_ENV \
-        "loadaddr=0x84000000\0" \
-        "kernel_addr_r=0x84000000\0" \
-        "fdtaddr=0x88000000\0" \
-        "dtboaddr=0x89000000\0" \
-        "fdt_addr_r=0x88000000\0" \
-        "fdtoverlay_addr_r=0x89000000\0" \
-        "rdaddr=0x88080000\0" \
-        "ramdisk_addr_r=0x88080000\0" \
-        "scriptaddr=0x80000000\0" \
-        "pxefile_addr_r=0x80100000\0" \
-        "bootm_size=0x10000000\0" \
-        "boot_fdt=try\0"
-#else
 #define DEFAULT_LINUX_BOOT_ENV \
 	"loadaddr=0x82000000\0" \
 	"kernel_addr_r=0x82000000\0" \
@@ -59,7 +44,6 @@
 	"pxefile_addr_r=0x80100000\0" \
 	"bootm_size=0x10000000\0" \
 	"boot_fdt=try\0"
-#endif
 
 #define DEFAULT_FIT_TI_ARGS \
 	"boot_fit=0\0" \
diff --git a/scripts/tispl-linux-falcon.sh b/scripts/tispl-linux-falcon.sh
deleted file mode 100755
index af2ede93..00000000
--- a/scripts/tispl-linux-falcon.sh
+++ /dev/null
@@ -1,103 +0,0 @@
-#!/bin/sh
-# SPDX-License-Identifier: GPL-2.0+
-#
-# script to generate FIT image source for K3 Family boards with ATF, OPTEE,
-# Device Manager, Linux Kernel, and device tree (given on the command line)
-# to support a direct R5 SPL -> Linux Kernel boot flow.
-#
-# Inspired from toolsk3_fit_atf.sh
-#
-# Copyright (C) 2023 Texas Instruments Incorporated - http://www.ti.com/
-#	Andreas Dannenberg <dannenberg@ti.com>
-#
-# usage: $0 <kernel_name> <dt_name>
-
-[ -z "$ATF" ] && ATF="bl31.bin"
-
-if [ ! -f $ATF ]; then
-	echo "WARNING ATF file $ATF NOT found, resulting binary is non-functional" >&2
-	ATF=/dev/null
-fi
-
-[ -z "$TEE" ] && TEE="bl32.bin"
-
-if [ ! -f $TEE ]; then
-	echo "WARNING OPTEE file $TEE NOT found, resulting might be non-functional" >&2
-	TEE=/dev/null
-fi
-
-[ -z "$DM" ] && DM="dm.bin"
-
-if [ ! -e $DM ]; then
-	echo "WARNING DM file $DM NOT found, resulting might be non-functional" >&2
-	DM=/dev/null
-fi
-
-cat << __ITS_EOF
-/dts-v1/;
-
-/ {
-	description = "Configuration to load ATF and SPL";
-	#address-cells = <1>;
-
-	images {
-		atf {
-			description = "ARM Trusted Firmware";
-			data = /incbin/("$ATF");
-			type = "firmware";
-			arch = "arm64";
-			compression = "none";
-			os = "arm-trusted-firmware";
-			load = <0x9e780000>;		/* This load/entry address pair is for use with AM62Ax */
-			entry = <0x9e780000>;
-		};
-		tee {
-			description = "OPTEE";
-			data = /incbin/("$TEE");
-			type = "tee";
-			arch = "arm64";
-			compression = "none";
-			os = "tee";
-			load = <0x9e800000>;		/* Needs to match BL32_BASE in ATF */
-			entry = <0x9e800000>;
-		};
-		dm {
-			description = "DM binary";
-			data = /incbin/("$DM");
-			type = "firmware";
-			arch = "arm32";
-			compression = "none";
-			os = "DM";
-			load = <0x89000000>;
-			entry = <0x89000000>;
-		};
-		kernel {
-			description = "Linux Kernel (64-bit)";
-			data = /incbin/("$1");
-			type = "standalone";
-			os = "linux";
-			arch = "arm64";
-			compression = "none";
-			load = <0x80080000>;		/* Needs to match PRELOADED_BL33_BASE in ATF */
-			entry = <0x80080000>;
-		};
-		fdt {
-			description = "$(basename $2 .dtb)";
-			data = /incbin/("$2");
-			type = "flat_dt";
-			arch = "arm";
-			compression = "none";
-			load = <0x82000000>;		/* Needs to match K3_HW_CONFIG_BASE in ATF */
-		};
-	};
-	configurations {
-		default = "$(basename $2 .dtb)";
-
-		$(basename $2 .dtb) {
-			description = "$(basename $2 .dtb)";
-			firmware = "atf";
-			loadables = "tee", "dm", "kernel", "fdt";
-		};
-	};
-};
-__ITS_EOF
\ No newline at end of file