--- a/ti_components/drivers/pdk_01_10_04_05/packages/ti/drv/pm/src/pmhal/prcm/V0/hw_pmhal_vmdata.c
+++ b/ti_components/drivers/pdk_01_10_04_05/packages/ti/drv/pm/src/pmhal/prcm/V0/hw_pmhal_vmdata.c
@@ -198,7 +198,7 @@ static const pmhalVmOppVoltage_t
 {
     /* VD_MPU voltage domain OPP definitions */
     {
-        /* VD_MPU, OPP Low Voltage Initialization, OPP_LOW is supported only
+        /* VD_MPU, OPP Low Voltage Initialization (ABB Disabled), OPP_LOW is supported only
          * for 17x17 package */
         {0U,    1060U},
         SOC_SEC_EFUSE_REGISTERS_BASE + CTRL_CORE_STD_FUSE_OPP_VMIN_MPU_1,
@@ -209,10 +209,10 @@ static const pmhalVmOppVoltage_t
         SOC_CTRL_MODULE_WKUP_CORE_REGISTERS_BASE +
         CTRL_WKUP_LDOVBB_MPU_VOLTAGE_CTRL,
         1,
-        1
+        0
     },
     {
-        /* VD_MPU, OPP NOM voltage Initialization : AVS & ABB Supported */
+        /* VD_MPU, OPP NOM voltage Initialization : AVS Supported, ABB Disabled */
         {1150U, 1150U},
         SOC_SEC_EFUSE_REGISTERS_BASE + CTRL_CORE_STD_FUSE_OPP_VMIN_MPU_2,
         SOC_OCP_SOCKET_PRM_BASE + PRM_IRQSTATUS_MPU_2,
@@ -222,10 +222,10 @@ static const pmhalVmOppVoltage_t
         SOC_CTRL_MODULE_WKUP_CORE_REGISTERS_BASE +
         CTRL_WKUP_LDOVBB_MPU_VOLTAGE_CTRL,
         1U,
-        1U
+        0U
     },
     {
-        /* VD_MPU, OPP OD voltage Initialization : AVS & ABB Supported */
+        /* VD_MPU, OPP OD voltage Initialization : AVS Supported, ABB Disabled */
         {1150U, 1150U},
         SOC_SEC_EFUSE_REGISTERS_BASE + CTRL_CORE_STD_FUSE_OPP_VMIN_MPU_3,
         SOC_OCP_SOCKET_PRM_BASE + PRM_IRQSTATUS_MPU_2,
@@ -235,10 +235,10 @@ static const pmhalVmOppVoltage_t
         SOC_CTRL_MODULE_WKUP_CORE_REGISTERS_BASE +
         CTRL_WKUP_LDOVBB_MPU_VOLTAGE_CTRL,
         1U,
-        1U
+        0U
     },
     {
-        /* VD_MPU, OPP High Voltage Initialization */
+        /* VD_MPU, OPP High Voltage Initialization : AVS Supported, ABB Disabled */
         {1250U, 1250U},
         SOC_SEC_EFUSE_REGISTERS_BASE + CTRL_CORE_STD_FUSE_OPP_VMIN_MPU_4,
         SOC_OCP_SOCKET_PRM_BASE + PRM_IRQSTATUS_MPU_2,
@@ -248,7 +248,7 @@ static const pmhalVmOppVoltage_t
         SOC_CTRL_MODULE_WKUP_CORE_REGISTERS_BASE +
         CTRL_WKUP_LDOVBB_MPU_VOLTAGE_CTRL,
         1U,
-        1U
+        0U
     },
     {
         /*
@@ -267,7 +267,7 @@ static const pmhalVmOppVoltage_t
         0U
     },
     {
-        /* VD_IVAHD OPP NOM Voltage Initialization  : AVS & ABB Supported */
+        /* VD_IVAHD OPP NOM Voltage Initialization  : AVS Supported, ABB Disabled */
         {1060U, 1060U},
         SOC_CTRL_MODULE_CORE_CORE_REGISTERS_BASE +
         CTRL_CORE_STD_FUSE_OPP_VMIN_IVA_2,
@@ -278,10 +278,10 @@ static const pmhalVmOppVoltage_t
         SOC_CTRL_MODULE_CORE_CORE_REGISTERS_BASE +
         CTRL_CORE_LDOVBB_IVA_VOLTAGE_CTRL,
         1U,
-        1U
+        0U
     },
     {
-        /* VD_IVAHD OPP OD Voltage Initialization  : AVS & ABB Supported */
+        /* VD_IVAHD OPP OD Voltage Initialization  : AVS Supported, ABB Disabled */
         {1150U, 1150U},
         SOC_CTRL_MODULE_CORE_CORE_REGISTERS_BASE +
         CTRL_CORE_STD_FUSE_OPP_VMIN_IVA_3,
@@ -292,10 +292,10 @@ static const pmhalVmOppVoltage_t
         SOC_CTRL_MODULE_CORE_CORE_REGISTERS_BASE +
         CTRL_CORE_LDOVBB_IVA_VOLTAGE_CTRL,
         1U,
-        1U
+        0U
     },
     {
-        /* VD_IVAHD OPP High Voltage Initialization : AVS & ABB Supported */
+        /* VD_IVAHD OPP High Voltage Initialization : AVS Supported, ABB Disabled */
         {1250U, 1250U},
         SOC_CTRL_MODULE_CORE_CORE_REGISTERS_BASE +
         CTRL_CORE_STD_FUSE_OPP_VMIN_IVA_4,
@@ -306,10 +306,10 @@ static const pmhalVmOppVoltage_t
         SOC_CTRL_MODULE_CORE_CORE_REGISTERS_BASE +
         CTRL_CORE_LDOVBB_IVA_VOLTAGE_CTRL,
         1U,
-        1U
+        0U
     },
     {
-        /* VD_DSPEVE OPP NOM Voltage Initialization : AVS & ABB Supported */
+        /* VD_DSPEVE OPP NOM Voltage Initialization : AVS Supported, ABB Disabled */
         {1060U, 1060U},
         SOC_CTRL_MODULE_CORE_CORE_REGISTERS_BASE +
         CTRL_CORE_STD_FUSE_OPP_VMIN_DSPEVE_2,
@@ -320,10 +320,10 @@ static const pmhalVmOppVoltage_t
         SOC_CTRL_MODULE_CORE_CORE_REGISTERS_BASE +
         CTRL_CORE_LDOVBB_DSPEVE_VOLTAGE_CTRL,
         1U,
-        1U
+        0U
     },
     {
-        /* VD_DSPEVE OPP OD Voltage Initialization : AVS & ABB Supported */
+        /* VD_DSPEVE OPP OD Voltage Initialization : AVS Supported, ABB Disabled */
         {1150U, 1150U},
         SOC_CTRL_MODULE_CORE_CORE_REGISTERS_BASE +
         CTRL_CORE_STD_FUSE_OPP_VMIN_DSPEVE_3,
@@ -334,7 +334,7 @@ static const pmhalVmOppVoltage_t
         SOC_CTRL_MODULE_CORE_CORE_REGISTERS_BASE +
         CTRL_CORE_LDOVBB_DSPEVE_VOLTAGE_CTRL,
         1U,
-        1U
+        0U
     },
     {
         /*
@@ -351,7 +351,7 @@ static const pmhalVmOppVoltage_t
         SOC_CTRL_MODULE_CORE_CORE_REGISTERS_BASE +
         CTRL_CORE_LDOVBB_DSPEVE_VOLTAGE_CTRL,
         1U,
-        1U
+        0U
     },
     {
         /* VD_GPU OPP NOM Voltage Initialization : AVS & ABB Supported */
@@ -412,7 +412,7 @@ static const pmhalVmOppVoltage_t
     },
 #if defined (SOC_TDA2EX)
     {
-        /* VD_IVAHD OPP High Voltage Initialization : AVS & ABB Supported */
+        /* VD_IVAHD OPP PLUS Voltage Initialization : AVS Supported, ABB Disabled */
         {1250U, 1250U},
         SOC_CTRL_MODULE_CORE_CORE_REGISTERS_BASE +
         CTRL_CORE_STD_FUSE_OPP_VMIN_IVA_5,
@@ -423,10 +423,10 @@ static const pmhalVmOppVoltage_t
         SOC_CTRL_MODULE_CORE_CORE_REGISTERS_BASE +
         CTRL_CORE_LDOVBB_IVA_VOLTAGE_CTRL,
         1U,
-        1U
+        0U
     },
     {
-        /* VD_DSPEVE OPP NOM Voltage Initialization : AVS & ABB Supported */
+        /* VD_DSPEVE OPP PLUS Voltage Initialization : AVS Supported, ABB Disabled */
         {1250U, 1250U},
         SOC_CTRL_MODULE_CORE_CORE_REGISTERS_BASE +
         CTRL_CORE_STD_FUSE_OPP_VMIN_DSPEVE_5,
@@ -437,7 +437,7 @@ static const pmhalVmOppVoltage_t
         SOC_CTRL_MODULE_CORE_CORE_REGISTERS_BASE +
         CTRL_CORE_LDOVBB_DSPEVE_VOLTAGE_CTRL,
         1U,
-        1U
+        0U
     }
 #endif
 };